# array-x.js
Functional extension methods (inspired by LINQ .NET) on JavaScript arrays


## Examples
```
require("array-x");

var arr = [
    new Date(),
    /abc[.]+/g,
    "a", "b", "c",
    1, 2, 3, 4, 5, 6, 7,
    [
        0,
        1
    ],
    [
        2,
        3
    ],
    [
        4,
        5,
        [
            6,
            7,
            [
                8,
                [
                    9,
                    10
                ]
            ]
        ]
    ],
    "last"
];

console.log("first(): " + arr.first());
console.log("last(): " + arr.last());
console.log("skip(2): " + arr.skip(2));
console.log("where(x=>x>3):" + arr.where(x => x > 3));
console.log("select(x=>x.length): " + arr.select(x => x.length));

```

Output:
```
first(): Wed Sep 14 2016 12:33:57 GMT-0700 (PDT)
last(): last
skip(2): a,b,c,1,2,3,4,5,6,7,0,1,2,3,4,5,6,7,8,9,10,last
where(x=>x>3):Wed Sep 14 2016 12:33:57 GMT-0700 (PDT),4,5,6,7
select(x=>x.length): ,,1,1,1,,,,,,,,2,2,3,4

```


## API
Array.prototype.forAll(function);

Array.prototype.select(function);

Array.prototype.distinct();

Array.prototype.where(function);

Array.prototype.all(function);

Array.prototype.any(function);

Array.prototype.accumulate(initial, function);

Array.prototype.firstOrDefault(function);

Array.prototype.first(function);

Array.prototype.lastOrDefault(function);

Array.prototype.last(function);

Array.prototype.take(count)

Array.prototype.skip(count)

Array.prototype.union(array);

Array.prototype.orderBy(function);

Array.prototype.orderByDesc(function);

Array.prototype.sum(function);

Array.prototype.count(function);

Array.prototype.avg(function);

Array.prototype.max(function);

Array.prototype.min(function);

Array.prototype.groupBy(function);

Array.prototype.groupByNumber(keyCount);

Array.prototype.groupAggregate(key, value, aggregation);

Array.prototype.removeItem(item);

Array.prototype.removeAt(index);

Array.prototype.insert(index, item);


## Install
npm install array-x --save

